Index: branches/PublicaMundi_David-devel/workshop/2010/index.rst
===================================================================
--- branches/PublicaMundi_David-devel/workshop/2010/index.rst	(revision 707)
+++ branches/PublicaMundi_David-devel/workshop/2010/index.rst	(revision 715)
@@ -1,7 +1,7 @@
 .. _workshop-foss4g-japan-2010:
 
-##############################################################
+
 ZOO-Project Workshop 2010
-##############################################################
+======================================================
 
 :Original Title: **Practical Introduction to ZOO: The Open WPS Platform**
Index: branches/PublicaMundi_David-devel/workshop/2010/introduction.rst
===================================================================
--- branches/PublicaMundi_David-devel/workshop/2010/introduction.rst	(revision 707)
+++ branches/PublicaMundi_David-devel/workshop/2010/introduction.rst	(revision 715)
@@ -2,5 +2,5 @@
 
 Introduction
-############
+======================================================
 
 .. contents:: Table of Contents
@@ -9,5 +9,5 @@
 
 What is ZOO ?
-*************
+--------------------------------------------------------------------
 
 ZOO is a WPS (Web Processing Service) open source project recently released under a `MIT/X-11 <http://zoo-project.org/trac/wiki/Licence>`__ style license. It provides an OGC WPS compliant developer-friendly framework to create and chain WPS Web services. ZOO is made of three parts:
@@ -24,5 +24,5 @@
 
 How does ZOO works ?
-********************
+--------------------------------------------------------------------
 
 ZOO is based on a 'WPS Service Kernel' which constitutes the ZOO's core system 
@@ -44,5 +44,5 @@
 
 What are we going to do in this workshop?
-*****************************************
+--------------------------------------------------------------------
 
 This workshop aims to present the ZOO Project and its features, and to explain its 
@@ -77,5 +77,5 @@
 
 Usefull tips for reading :
-**************************
+--------------------------------------------------------------------
 
 .. code-block:: guess
@@ -88,5 +88,3 @@
 
 
-
-
 **Let's go !**
Index: branches/PublicaMundi_David-devel/workshop/2010/ogr_base_vect_ops.rst
===================================================================
--- branches/PublicaMundi_David-devel/workshop/2010/ogr_base_vect_ops.rst	(revision 707)
+++ branches/PublicaMundi_David-devel/workshop/2010/ogr_base_vect_ops.rst	(revision 715)
@@ -2,5 +2,5 @@
 
 Creating OGR based Web Services
-===============================
+======================================================
 
 .. contents:: Table of Contents
@@ -9,5 +9,5 @@
 
 Introduction
-------------
+--------------------------------------------------------------------
 
 In this part, we are going to create a ZOO ServicesProvider containing several Services 
@@ -29,5 +29,5 @@
 
 Preparing ZOO metadata file
----------------------------
+--------------------------------------------------------------------
 
 A ZOO Service is a combination of a ZOO metadata file (``.zcfg``) and the runtime module 
@@ -196,5 +196,5 @@
 
 Implementing single geometry services
--------------------------------------
+------------------------------------------------------------------------------
 
 In order to learn the Services Provider creation and deployement step-by-step, 
@@ -213,8 +213,8 @@
 
 Boundary
-********
+..........................................................................................................................................................
 
 C Version
-^^^^^^^^^
+*******************************************************************************************************
 
 As explained before, ZOO Kernel will pass the parameters to your Service function 
@@ -577,5 +577,5 @@
 
 Python Version
-^^^^^^^^^^^^^^
+*******************************************************************************************************
 
 For those using Python to implement their ZOO Services Provider, the full code to copy in 
@@ -634,5 +634,5 @@
 
 Testing the Service using Execute Request
-^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+...............................................................................................................................................
 
 **The simple and unreadable way**
@@ -877,5 +877,6 @@
 
 Creating Services for other functions (ConvexHull and Centroid)
-***************************************************************
+.........................................................................................................................................................
+
 
 As the Boundary sample service code is available, you can now easily add ConvexHull and 
@@ -885,6 +886,5 @@
 
 C Version
-^^^^^^^^^
-
+*******************************************************************************************************
 Please add first the following code to the service.c source code : 
 
@@ -1019,5 +1019,5 @@
 
 Python Version
-^^^^^^^^^^^^^^
+*******************************************************************************************************
 
 .. code-block:: guess
@@ -1104,5 +1104,5 @@
 
 Create the Buffer Service
-*************************
+
 
 We can now work on the Buffer Service, which takes more arguments than the other ones. 
@@ -1115,5 +1115,5 @@
 
 C Version
-^^^^^^^^^
+*******************************************************************************************************
 
 If you go back to the first Boundary Service source code, you should not find the 
@@ -1223,5 +1223,5 @@
 
 Python Version
-^^^^^^^^^^^^^^
+*******************************************************************************************************
 
 As we already defined the utility functions createGeometryFromWFS and outputResult, 
@@ -1248,5 +1248,5 @@
 
 The Buffer MetadataFile file
-^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+*******************************************************************************************************
 
 You must add BufferDistance to the Service Metadata File to let clients know that 